



#include "OmSourceParameters.h"


#include "Dal.h"
#include "astrometrydefs.h"
#include "utility.h"


#include<iostream>

/************************************************************
*
************************************************************/
bool compare(const matchedData &a, const matchedData & b)
{
    return a.distance < b.distance;

};





/************************************************************
*
************************************************************/

double EquatorialCoordinates::arcLength( EquatorialCoordinates & a)
{

    return acos( min( 1.0, (x * a.x + y * a.y + z * a.z))) * radiansToArcSecs;


};

/*****************************************************
*
* Computes the equatorial rectangular coordinates
*
*****************************************************/


EquatorialCoordinates::EquatorialCoordinates(double raIn, double decIn)
{
    ra = raIn;
    dec = decIn;

    computeEquatorialCoordinates();


};

/*******************************************************************
*
*
*******************************************************************/
void EquatorialCoordinates::computeEquatorialCoordinates()
{

    double cosDec = cos( dec );

    x = cosDec * cos( ra );
    y = cosDec * sin( ra );
    z = sin( dec );
           

};
    
/**************************************************************
*
**************************************************************/    
void EquatorialCoordinates::computeSphericalCoordinates()
{



    ::computeSphericalCoordinates(x, y, z, ra, dec);


       
   
};
/************************************************************************
*
*
*************************************************************************/
void averageCelestialCoordinates(vector<double> &ra, vector<double> &dec, 
            double &raMean, double &decMean)
{


    double x = 0.0, y = 0.0, z = 0.0;
    for(unsigned i = 0; i < ra.size(); i++)
    {
        double cosDec = cos( dec[i] * degreesToRadians );

	//	if(i > 0)
	//	{
	//double d = distance( ra[0] * degreesToRadians, dec[0] * degreesToRadians, ra[i] * degreesToRadians, dec[i] * degreesToRadians);
        
	//  if( d > 3.0) 
	// {
	//    cout << "ra[0]=" << ra[0] << " ra " << i << " =" << ra[i] << endl;
	//    cout << "possible bug in averagecelstialcoordinates- astrometrydefs.cc\n";
	// }

	//        }

        x += cosDec * cos( ra[i] * degreesToRadians );
        y += cosDec * sin( ra[i] * degreesToRadians);
        z += sin( dec[i] * degreesToRadians );
     

    }

    computeSphericalCoordinates(x, y, z, raMean, decMean);
    raMean *= radiansToDegrees;
    decMean *= radiansToDegrees;


}
/*********************************************************
*
**********************************************************/
void computeSphericalCoordinates(double x, double y, double z, double &raMean, double &decMean)
{
   double delta = sqrt(x * x + y * y + z * z);
    
    if( x == 0.0 and y == 0.0)
    {
        raMean = 0.0;


    }
    else if(x == 0.0 and y > 0.0)
    {
        raMean = M_PI / 2.0;

    } 
    
    else if( x < 0.0 and y == 0.0)
    { 
   
        raMean = M_PI;
    }    
    else if( x == 0.0 and y < 0.0)
    { 
   
        raMean = 1.5 * M_PI;
    }


    else    
    {


        
	raMean = abs( atan2(y, x));  
       
	if(y < 0.0) 
	{
	    raMean = 2.0 * M_PI - raMean;
               
        }; 
        
    }

    if( abs(z) > 0.0)
        decMean = asin( z / delta);
    else
	decMean = 0.0;  
           
    
}







