#ifndef GRAPH_H
#define GRAPH_H
#include<vector>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<numeric>
#include "statistics.h"
#include"utility.h"
#include <f90cxx.h>
#include<iostream>

//#include "cpgplot.h"





class Graph
{
    public:
        Graph() {};
       ~Graph();
        static vector<float> x1List, x2List, y1List, y2List;
        static vector<float> xminList, xmaxList, yminList, ymaxList;

};











/*******************************************************************************************
*
*
*
*
********************************************************************************************/


/*******************************************************************************************
*
*
*
*
********************************************************************************************/
F90MODPROCPROTO( void, pggraph_mod, pgpage1)();

F90MODPROCPROTO( void, pggraph_mod, pgrnge1)(float *, float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, pgsvp1)(float *, float *, float *, float *);
F90MODPROCPROTO( void, pggraph_mod, pgswin1)(float *, float *, float *, float *);
F90MODPROCPROTO( void, pggraph_mod, pgwnad1)(float *, float *, float *, float *);

      
F90MODPROCPROTO( void, pggraph_mod, pgmove1)(float *, float *);
F90MODPROCPROTO( void, pggraph_mod, pgdraw1)(float *, float *);

F90MODPROCPROTO( int, pggraph_mod, pgopen1)();


F90MODPROCPROTO( void, pggraph_mod, pgclos1)(void);




F90MODPROCPROTO( void, pggraph_mod, pgline1)(int *, float *, float *);


F90MODPROCPROTO( void, pggraph_mod, pgpt11)(int *, float *, float *, int*);
F90MODPROCPROTO( void, pggraph_mod, pgpt111)(float *, float *, int *);


F90MODPROCPROTO( void, pggraph_mod, pgerr11)(int *, float *, float *, float *, int *);
F90MODPROCPROTO( void, pggraph_mod, pgerrx1)(int *, float *, float *, float *, int *);
F90MODPROCPROTO( void, pggraph_mod, pgerry1)(int *, float *, float *, float *, int *);
F90MODPROCPROTO( void, pggraph_mod, pgcirc1)(float *, float *, float *);


F90MODPROCPROTO( float, pggraph_mod, pgrnd1)(float *, int *);




F90MODPROCPROTO( void, pggraph_mod, pgrect1)(float *, float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, pgscr1)(int *, float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, setlabel)();
F90MODPROCPROTO( void, pggraph_mod, setxlabel)();
F90MODPROCPROTO( void, pggraph_mod, setylabel)();
F90MODPROCPROTO( void, pggraph_mod, settitle)();

F90MODPROCPROTO( void, pggraph_mod, settextposition)();

F90MODPROCPROTO( void, pggraph_mod, pgmtxt1)(float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, pglab1)(void);


F90MODPROCPROTO( void, pggraph_mod, setxboxformat)();
F90MODPROCPROTO( void, pggraph_mod, setyboxformat)();

F90MODPROCPROTO( void, pggraph_mod, pgbox1)(float *, int *, float *, int *);




F90MODPROCPROTO( void, pggraph_mod, pgschi1)(float *);

F90MODPROCPROTO( void, pggraph_mod, pgsls1)(int *);
F90MODPROCPROTO( void, pggraph_mod, pgsfs1)(int *);
F90MODPROCPROTO( void, pggraph_mod, pgslw1)(int *);
F90MODPROCPROTO( void, pggraph_mod, pgsci1)(int *);

F90MODPROCPROTO( void, pggraph_mod, pgsubp1)(int *, int *);
F90MODPROCPROTO( void, pggraph_mod, pgpanl1)(int *, int *);




F90MODPROCPROTO( void, pggraph_mod, pghist1)(int *, float *, float *, float *, int *, int *);


/********************************************************************
*
*
*********************************************************************/
void cbpglab(char *xlabel, char *ylabel, char *title );


/**************************************************************
*
*
***************************************************************/
void cbpgmtxt(const char *position, float x1, float x2, float x3, const char *label);



/********************************************************************
*
*
*
*********************************************************************/
void cbpgpage();


/********************************************************************
*
*
*
*********************************************************************/
void cbpgclos();

/********************************************************************
*
*
*
*********************************************************************/
int cbpgopen(char *file);


/**********************************************************
*
*
**********************************************************/
float cbpgrnd( float binWidth, int nsub );
 
/**********************************************************
*
*
**********************************************************/
void cbpgcirc( float x, float y, float radius );
 


/********************************************************************
*
*
*********************************************************************/
void cbpgmove(float x, float y);

/********************************************************************
*
*
*********************************************************************/
void cbpgdraw(float x, float y);


/********************************************************************
*
*
*********************************************************************/
void cbpgsubp(int x, int y);

/********************************************************************
*
*
*********************************************************************/
void cbpgpanl(int x, int y);





/********************************************************************
*
*
*********************************************************************/
void cbpgrnge(float x1, float y1, float *x2, float *y2);



/********************************************************************
*
*
*********************************************************************/
void cbpgsvp(float x1, float x2, float y1, float y2);

/********************************************************************
*
*
*********************************************************************/
void cbpgswin(float x1, float x2, float y1, float y2);

/********************************************************************
*
*
*********************************************************************/
void cbpgrect(float x1, float x2, float y1, float y2);







/********************************************************************
*
*
*********************************************************************/
void cbpgwnad(float x1, float x2, float y1, float y2);



/********************************************************************
*
*
*********************************************************************/
void cbpgscr(int x1, float x2, float y1, float y2);








/********************************************************************
*
*
*********************************************************************/
void cbpgline(int nData, float *x, float *y);
/********************************************************************
*
*
*********************************************************************/
void cbpgpt(int nData, float *x, float *y, int symbol);
/********************************************************************
*
*
*********************************************************************/
void cbpgpt1(float x, float y, int symbol);




/********************************************************************
*
*
*********************************************************************/
void cbpgerr1(int k, float x, float y, float error, int k1);


/********************************************************************
*
*
*********************************************************************/
void cbpgerrx(int nData, float *x, float *y, float *error, int k);

/********************************************************************
*
*
*********************************************************************/
void cbpgerry(int nData, float *x, float *y, float *error, int k);











/********************************************************************
*
*
*********************************************************************/
void cbpgsch(float size);

/********************************************************************
*
*
*********************************************************************/
void cbpgsls(int style);



/********************************************************************
*
*
*********************************************************************/
void cbpgslw(int width);

/********************************************************************
*
*
*********************************************************************/
void cbpgsfs(int type);


/********************************************************************
*
*
*********************************************************************/
void cbpgsci(int colour);

/******************************************************************
*
*
*****************************************************************/
void cbpgbox(const char *xformat, float x, int k1, const char *yformat, float y, int k2);

/********************************************************************
*
*
*
*
*********************************************************************/
void cbpghist(int nData, float *xData, float xmin, float xmax, int noBins, int type);




using namespace std;







void SetUpColourIndices( bool display = false );
void SetUpDefaultColourIndices( );


void setColour(int col);

void setSymbol(int col);
void setMaxNoBins(int no);
int getColour();
int getSymbol();


int getMaxNoBins();






void convert(float xData, float ydata, float &x, float &y);




struct BinData
{ 
  float dx;
  float xMin;
  float xMax;
  string label1, label2, label3;
}; 


void action1(vector<float> &x, vector<float> &y, void * data);










/***************************************************************
*
*
****************************************************************/
float Median(float *data, long nData);    




float Percentile(vector<float> &data, float perCent);

float Percentile(float *data, long nData, float perCent);










/****************************************************************
*
*
* Several graphs on top of one another
*
*
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                vector< vector<float> > &dyData,
                vector<int>  &colourIndex,
                vector<string> &subTitle, 
                char *xlabel,
                char *ylabel, 
                char *title, 
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                vector<float> &yMin, 
                vector<float> &yMax,
                bool equalAxes,
                float dw1, float dw2 = 0.05);
  



#endif


