#ifndef GRAPH_H
#define GRAPH_H
#include<vector>
#include<string>
#include<cmath>
#include<algorithm>
#include<numeric>
#include "statistics.h"
#include"utility.h"
#include <f90cxx.h>
#include<iostream>


/*******************************************************************************************
*
*
*
*
********************************************************************************************/

F90MODPROCPROTO( void, minimize_mod, minimum)(int *, double *, double *, double * , double *, double *);

/*******************************************************************************************
*
*
*
*
********************************************************************************************/
F90MODPROCPROTO( void, pggraph_mod, pgpage1)();

F90MODPROCPROTO( void, pggraph_mod, pgrnge1)(float *, float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, pgsvp1)(float *, float *, float *, float *);
F90MODPROCPROTO( void, pggraph_mod, pgswin1)(float *, float *, float *, float *);
F90MODPROCPROTO( void, pggraph_mod, pgwnad1)(float *, float *, float *, float *);

      
F90MODPROCPROTO( void, pggraph_mod, pgmove1)(float *, float *);
F90MODPROCPROTO( void, pggraph_mod, pgdraw1)(float *, float *);

F90MODPROCPROTO( int, pggraph_mod, pgopen1)();


F90MODPROCPROTO( void, pggraph_mod, pgclos1)(void);




F90MODPROCPROTO( void, pggraph_mod, pgline1)(int *, float *, float *);


F90MODPROCPROTO( void, pggraph_mod, pgpt11)(int *, float *, float *, int*);
F90MODPROCPROTO( void, pggraph_mod, pgpt111)(float *, float *, int *);


F90MODPROCPROTO( void, pggraph_mod, pgerr11)(int *, float *, float *, float *, int *);
F90MODPROCPROTO( void, pggraph_mod, pgerrx1)(int *, float *, float *, float *, int *);
F90MODPROCPROTO( void, pggraph_mod, pgerry1)(int *, float *, float *, float *, int *);


F90MODPROCPROTO( float, pggraph_mod, pgrnd1)(float *, int *);




F90MODPROCPROTO( void, pggraph_mod, pgrect1)(float *, float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, pgscr1)(int *, float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, setlabel)();
F90MODPROCPROTO( void, pggraph_mod, setxlabel)();
F90MODPROCPROTO( void, pggraph_mod, setylabel)();
F90MODPROCPROTO( void, pggraph_mod, settitle)();

F90MODPROCPROTO( void, pggraph_mod, settextposition)();

F90MODPROCPROTO( void, pggraph_mod, pgmtxt1)(float *, float *, float *);

F90MODPROCPROTO( void, pggraph_mod, pglab1)(void);


F90MODPROCPROTO( void, pggraph_mod, setxboxformat)();
F90MODPROCPROTO( void, pggraph_mod, setyboxformat)();

F90MODPROCPROTO( void, pggraph_mod, pgbox1)(float *, int *, float *, int *);




F90MODPROCPROTO( void, pggraph_mod, pgschi1)(float *);

F90MODPROCPROTO( void, pggraph_mod, pgsls1)(int *);
F90MODPROCPROTO( void, pggraph_mod, pgsfs1)(int *);
F90MODPROCPROTO( void, pggraph_mod, pgslw1)(int *);
F90MODPROCPROTO( void, pggraph_mod, pgsci1)(int *);

F90MODPROCPROTO( void, pggraph_mod, pgsubp1)(int *, int *);
F90MODPROCPROTO( void, pggraph_mod, pgpanl1)(int *, int *);




F90MODPROCPROTO( void, pggraph_mod, pghist1)(int *, float *, float *, float *, int *, int *);


/********************************************************************
*
*
*********************************************************************/
void cbpglab(char *xlabel, char *ylabel, char *title );


/**************************************************************
*
*
***************************************************************/
void cbpgmtxt(const char *position, float x1, float x2, float x3, const char *label);



/********************************************************************
*
*
*
*********************************************************************/
void cbpgpage();


/********************************************************************
*
*
*
*********************************************************************/
void cbpgclos();

/********************************************************************
*
*
*
*********************************************************************/
int cbpgopen(char *file);


/**********************************************************
*
*
**********************************************************/
float cbpgrnd( float binWidth, int nsub );
 


/********************************************************************
*
*
*********************************************************************/
void cbpgmove(float x, float y);

/********************************************************************
*
*
*********************************************************************/
void cbpgdraw(float x, float y);


/********************************************************************
*
*
*********************************************************************/
void cbpgsubp(int x, int y);

/********************************************************************
*
*
*********************************************************************/
void cbpgpanl(int x, int y);





/********************************************************************
*
*
*********************************************************************/
void cbpgrnge(float x1, float y1, float *x2, float *y2);



/********************************************************************
*
*
*********************************************************************/
void cbpgsvp(float x1, float x2, float y1, float y2);

/********************************************************************
*
*
*********************************************************************/
void cbpgswin(float x1, float x2, float y1, float y2);

/********************************************************************
*
*
*********************************************************************/
void cbpgrect(float x1, float x2, float y1, float y2);







/********************************************************************
*
*
*********************************************************************/
void cbpgwnad(float x1, float x2, float y1, float y2);



/********************************************************************
*
*
*********************************************************************/
void cbpgscr(int x1, float x2, float y1, float y2);








/********************************************************************
*
*
*********************************************************************/
void cbpgline(int nData, float *x, float *y);
/********************************************************************
*
*
*********************************************************************/
void cbpgpt(int nData, float *x, float *y, int symbol);
/********************************************************************
*
*
*********************************************************************/
void cbpgpt1(float x, float y, int symbol);




/********************************************************************
*
*
*********************************************************************/
void cbpgerr1(int k, float x, float y, float error, int k1);


/********************************************************************
*
*
*********************************************************************/
void cbpgerrx(int nData, float *x, float *y, float *error, int k);

/********************************************************************
*
*
*********************************************************************/
void cbpgerry(int nData, float *x, float *y, float *error, int k);











/********************************************************************
*
*
*********************************************************************/
void cbpgsch(float size);

/********************************************************************
*
*
*********************************************************************/
void cbpgsls(int style);



/********************************************************************
*
*
*********************************************************************/
void cbpgslw(int width);

/********************************************************************
*
*
*********************************************************************/
void cbpgsfs(int type);


/********************************************************************
*
*
*********************************************************************/
void cbpgsci(int colour);

/******************************************************************
*
*
*****************************************************************/
void cbpgbox(const char *xformat, float x, int k1, const char *yformat, float y, int k2);

/********************************************************************
*
*
*
*
*********************************************************************/
void cbpghist(int nData, float *xData, float xmin, float xmax, int noBins, int type);




using namespace std;
/*****************************************************
* Subroutine Histogram- for 1 or more data setshistog
*
*
******************************************************/


//template<class type>
class HistData
{
public:
    HistData(float a, int b) : x(a), index(b) {};
    float x;
    int index;
};





/*******************************************************
*
********************************************************/
bool histCompare10(const HistData &a, const HistData &b);


F90MODPROCPROTO( void, minimize_mod, minimum)(int *, double *, double *, double * , double *, double *);



void SetUpColourIndices( bool display = false );
void SetUpDefaultColourIndices( );


void setColour(int col);

void setSymbol(int col);
void setMaxNoBins(int no);
int getColour();
int getSymbol();


int getMaxNoBins();






void convert(float xData, float ydata, float &x, float &y);




struct BinData
{ 
  float dx;
  float xMin;
  float xMax;
  string label1, label2, label3;
}; 


void action1(vector<float> &x, vector<float> &y, void * data);


void drawGraph( int ndata, 
                float* xdata, 
                float *xerrors, 
                float *ydata, 
                float *yerrors,
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                float xmin1 = -1.0, 
                float xmax1 = -1.0, 
                float ymin1 = -1.0, 
                float ymax1 = -1.0, 
                bool equalAxes = false);
  










void drawGraph( int ndata, 
                float* xdata,  
                float *ydata, 
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                float xmin1 = -1.0, 
                float xmax1 = -1.0, 
                float ymin1 = -1.0, 
                float ymax1 = -1.0, 
                bool equalAxes = false);
  



/****************************************************************
*
*
*****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata,
                vector< string >  &subTitle,
                char *xlabel, 
                char *ylabel, 
                char *title,
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw = 0.25);
  




/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                 char *xlabel, 
                char *ylabel, 
                char *title,
                vector<string> &subTitle, 
                float x1, 
                float x2,
                float y1,
                float y2,  
                float xmin1 = 0.0, 
                float xmax1 = 0.0, 
                float ymin1 = 0.0, 
                float ymax1 = 0.0);
  





/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata,
                void (*Action)( vector<float> &x, vector<float> &y, void *data),
                vector<void *> &data,
                vector< string >  &subTitle,
                char *xlabel, 
                char *ylabel, 
                char *title,
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw = 0.25);
  



        

/****************************************************************
 *
 *
 *****************************************************************/
void drawGraph( int ngraphs, 
                vector< vector<float> > &xdata,
                vector< vector<float> > &ydata, 
                vector< vector<float> > &bin,             
                vector< vector<float> > &median, 
                vector< vector<float> > &lBound, 
                vector< vector<float> > &uBound, 
                vector<string> &subTitle, 
                char *xlabel, 
                char *ylabel, 
                char *title, 
                float x1, 
                float x2,  
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes,
                float dw1 = 0.25);


/*****************************************************
* Subroutine Histogram
*
******************************************************/
void Histogram( int ndata, float *xBin, float *data, 
                 char *ylabel, char *xLabel, char *title, 
                 float x1, float x2, float y1, float y2, 
		float xmin, float xmax, float ymax = -1.0);



/*****************************************************
* Subroutine Histogram
*
******************************************************/
void Histogram( int ndata, int nBins, float *xBin, float **data, 
                 char *yLabel, char *xLabel, char *title, 
                 float x1, float x2, float y1, float y2, 
		float xmin, float xmax, float yMax);

    
  


void Histogram( int ndata, float *data, float binWidth, 
                 char *xLabel, char *title, 
		float x1, float x2, float y1, float y2, float xmin, float xmax);


    
/*****************************************************
* Subroutine Histogram
*
******************************************************/
void Histogram( vector< vector<float> >& data1, float binWidth, 
		vector<string> &subTitle, char *xlabel, 
                 char *title, 
                 float x1, float x2, 
		 float xmin, float xmax, float dr);
    


void Histogram( vector< vector<float> >& data1, float binWidth, 
		vector<string> &subTitle, char *xlabel, 
                 char *title, 
                 float x1, float x2, 
		 float xmin, float xmax);
    




/***************************************************************
*
*
****************************************************************/
float Median(float *data, long nData);    




float Percentile(vector<float> &data, float perCent);

float Percentile(float *data, long nData, float perCent);


/*********************************************************************
*
*
**********************************************************************/
void binnedData(vector<float>  &xData, 
                vector<float>  &yData,
                float xMin, 
                float xMax, 
                float dx,
                vector<float>  &bins,
                vector<float>  &median,
                vector<float>  &lower,
                vector<float>  &upper);










/*****************************************************
* Subroutine Histogram
*
******************************************************/
template<class type1, class type2>
void Histogram( vector<type1> & data, int noBins, 
                 char *xLabel, char *title, 
                 float x1, float x2, float y1, float y2, 
                 type2 xmin, type2 xmax)

{


    double binWidth = (xmax - xmin) / double(noBins);

    Histogram( data, binWidth, 
                 xLabel, title, 
                 x1, x2, y1, y2, 
	         xmin, xmax);



}


/*****************************************************
*
*
* Subroutine Histogram
*
*
******************************************************/
template<class type, class type1, class type2>
void Histogram( vector<type> & data, type1 binWidth1, 
                char *xLabel, char *title, 
                float x1, float x2, float y1, float y2, 
                type2 xmin1, type2 xmax1)

{


  //  cout << "HISTOGRAM line 671 binwidth=" << binWidth1 << endl;

    
    double binWidth = (double)binWidth1;
    if(xmax1 < xmin1) binWidth = -binWidth;

    double xmin = double(xmin1);
    double xmax = double(xmax1);
  

    // cout << "xmin=" << xmin << " xmax=" << xmax << " binwidth=" << binWidth << endl;



    /****************************************************
    * 
    *
    *****************************************************/
    if( (xmin == 0.0 && xmax == 0.0) || (abs(xmax) - abs(xmin)) < 1e-9) 
    {

        int noLeftBins = int(abs(xmin) / binWidth + 0.000000001);
        xmin = -(double(noLeftBins) * binWidth + binWidth / 2.0);
        int noRightBins = int(xmax / binWidth + 0.000000001);
        xmax = double(noRightBins) * binWidth + binWidth / 2.0;


    }




    //    cout << "Line 703 xmin=" << xmin << " xmax=" << xmax << " binwidth=" << binWidth << endl;


    
    int nData = data.size(); 



    // cout << "HISTOGRAM line 842 binwidth=" << binWidth1 << endl;


    // Sort the data
    sort( data.begin(), data.end() );

    if (fabs(xmin - xmax) < 1e-20) {
        cout << "Unable to draw histogram- xmin=xmax\n";
        return;
    }

   
 
    int noBins = int( (xmax - xmin) / binWidth + 0.0001 );
    
  
    if (noBins < 3) {
        cout << "omgraph- No of bins < 3\n";
        return;
    }
  
    






    //    cout << "HISTOGRAM line 739 nobins=" << noBins << endl;



    /******************************
    *
    * Find the maximum bin size
    *******************************/

    int *frequency = new int[noBins];
    float *bin = new float[noBins];
    float *height = new float[noBins];

    for (int i = 0; i < noBins; i++)
    {
        frequency[i] = 0;
        bin[i] = xmin + binWidth * double(i) + binWidth / 2.0;
    }

 
    int noLeft = 0, noRight = 0;


    //cout << "Line 893 noBins=" << noBins << " binwidth=" << binWidth << endl;

    for (int i = 0; i < nData; i++) 
    {
        int k = int( abs(data[i] - xmin) / binWidth + 0.00000001);       
        if (k < 0)
	{

	  //  cout << i << ") data=" << data[i] << " noleft=" << noLeft << " xmin=" << xmin << " binwidth=" << binWidth << endl; 
	    noLeft++;
            k = 0;
        }
        else if (k >= noBins)
	{
	    noRight++;
            k = noBins - 1;
        }
        frequency[k]++;
       
    }
    for(int i = 0; i < noBins; i++)
      height[i] = float(frequency[i] );
  


    




    int maxFreq =  MaxVal(frequency, noBins);
  
    float yMax = min(nData, (int)( float(maxFreq) * 1.50)); 


    //    cout << "Line 797 maxfreq=" << maxFreq << " ymax=" << yMax << endl;


    
    cbpgsvp(x1, x2, y1, y2);


    cbpgswin(xmin, xmax, 0.0, yMax);
         

    cbpgsci(1);     

    cbpgsch(1.0); 
    cbpgsfs(2);    
    cbpgslw(1);
    float *xData = new float[nData];
    for(int i = 0; i < nData; i++)
        xData[i] = data[i];





    //   cout << "HISTOGRAM line 820 nobins=" << noBins << endl;






    if(noBins >= 100 || MinVal(frequency, noBins) > max(100, nData / noBins) )    
    {
        cbpgline(noBins, bin, height);
    }
    else
    {

      //    cout << "Line 834 calling pghist xmin=" << xmin << " xmax=" << xmax << " nobins=" << noBins << endl;
        cbpghist(nData, xData, (float)xmin, (float)xmax, noBins, 3);
    }



    delete [] frequency;  
    delete [] bin;
    delete [] height;

    delete [] xData;





    cbpgswin((float)xmin, (float)xmax, 0.0, (yMax / float(nData)) * 100.0);

     
    cbpgsch(0.8);  

    if(noBins > getMaxNoBins())
    {
        for(int i = 0; i < 10; i++)
        {
            noBins = int( (xmax - xmin) / binWidth + 0.0001 );

            if(noBins > getMaxNoBins() ) 
                binWidth *= 2.0;
            else
	        break;
    
        }
    } 

    


    
  
    binWidth = abs(binWidth);


    cbpgbox("bctsi", binWidth, 5, "bctsi", 0.0, 0);

 



    cbpgsch(1.0);  
    cbpgbox("n", binWidth, 5, "n", 0.0, 0); 

  




    cbpgsch(0.9);  
    char text[100];
    int k = 1;

    if (noLeft > 0)
    {
     
        sprintf( text, "No of data points < %.2f=%*d", xmin, (int(log10((float)noLeft) + 0.00001) + 1), noLeft);        
        cbpgmtxt("T", -float(k), 0.0, 0.0, text);
        k++;
    }

    if (noRight> 0)
    {

     

        sprintf( text, "No of data points > %.2f=%d", xmax, noRight);        
        cbpgmtxt("T", -float(k), 0.0, 0.0, text);
        k++;
    }


 


    sort(data.begin(), data.end());
    // Get some statistics
    double mean = Mean(data);


    double median = Median(data);;
    double std = 0.0; 

    double mode = halfRangeMode( data, mean, std, median);

    double p1 = Percentile(data, 0.05);

    double p2 = Percentile(data, 0.95);




    sprintf(text, "Mean=%.2f, Median=%.2f, mode=%.2f, 0.05 percentile=%.2f, 0.95=%.2f", mean, median, mode, p1, p2);
 

    cbpgsch(1.2);  
  
   


    cbpgmtxt("T", -float(k), 0.0, 0.0, text);
 
  


    cbpgsch(1.2);

    char yLabel[100];



    sprintf( yLabel, "%s %d %s", "FREQUENCY (%) (TOTAL=", nData, ")" );
       


    cbpgslw(3);


    cbpglab((char *)" ", yLabel, title);


  

    cbpgmtxt((char *)"B", 2.0, 0.5, 0.5, xLabel);


    



    cbpgslw(1);
 
    cbpgswin(xmin, xmax, 0.0, yMax);
 
     



}


/*****************************************************
*
*
* Subroutine Histogram
*
*
******************************************************/

void Histogram1( vector<int16> & data, int16 binWidth1, 
                char *xLabel, char *title, 
                float x1, float x2, float y1, float y2, 
		 int16 xmin1, int16 xmax1);










/*****************************************************
* Subroutine Histogram - for 1 or more data sets
*
******************************************************/
template<class type1, class type2>
void Histogram( vector< vector<type1> > & data, float binWidth, 
                vector<string> &heading, char *xLabel, char *title, 
                float x1, float x2, float y1, float y2, 
                type2 xmin, type2 xmax, bool percentage=true)
{
    
  //    cout << "Histogram line 1030 binWidth=" << binWidth << endl;       

  
    int noBins = int( (xmax - xmin) / binWidth + 0.0001 );
    
  

    Histogram( data, noBins,   heading, xLabel, title, 
	       x1, x2, y1, y2, xmin, xmax, percentage);

   


} 
/*****************************************************************
*
* Draws one or more histograms on the same graph
*
*****************************************************************/
template<class type1, class type2>
void Histogram( vector< vector<type1> > & data, int noBins,   
                vector<string> &heading, char *xLabel, char *title, 
                float x1, float x2, float y1, float y2, 
                type2 xmin1, type2 xmax1, bool percentage = true)
{

    


    int noDataSets = data.size();   // The number of data sets



 
    double xmin = double(xmin1); 
    double xmax = double(xmax1); 


    //   cout << "HISTOGRAM LINE 1166 nodatasets=" << noDataSets << " xmin=" << xmin << " xmax=" << xmax << endl;
  
    if (abs(xmin - xmax) < 1e-20) {
        cout << "Unable to draw histogram", "xmin=xmax\n";
        return;
    }

   


    double binWidth = double(xmax - xmin) / (double)noBins ;
    


    /****************************************************
    * 
    *
    *****************************************************/

   

    if( xmin < 0.0 && xmax > 0.0) 
    {
      //  cout << "Histogram line 1170 initial xmin=" << xmin << " xmax=" << xmax << " binwidth=" << binWidth << endl;

        int noLeftBins = int( abs(xmin) / binWidth + 0.000000001);
        xmin = -( double(noLeftBins) * binWidth + binWidth / 2.0);
        int noRightBins = int(xmax / binWidth + 0.000000001);
        xmax = double(noRightBins) * binWidth + binWidth / 2.0;

	//      cout << "Histogram line 1181 final xmin=" << xmin << " xmax=" << xmax << " binwidth=" << binWidth << endl;
	//  cout << "noleftBins=" << noLeftBins << " right=" << noRightBins << endl;
       

    }
    

  
    if (noBins < 3) {
        cout << "omgraph", "No of bins < 3\n";
        return;
    }
  
   
    //    cout << "histogram line 3149\n";

 

    /******************************
     * Find the maximum bin size
     *******************************/

    int *frequency = new int[noBins];

   
    double yMax = 0.0;

    int noLeft = 0, noRight = 0;
   


    /****************************************************************
    * Loop through all the data sets
    * 
    *****************************************************************/
    vector<vector<float> > yData(noDataSets);
    

    double minimumFrequency = 0.0;
    for (int j = 0; j < noDataSets; j++)
    {
     

        int nData = data[j].size(); 

	//	cout << "Dataset " << j << " nadat=" << nData << endl;     
        
        for (int i = 0; i < noBins; i++)
            frequency[i] = 0;



        for (int i = 0; i < nData; i++) 
        {
            int k = int((data[j][i] - xmin) / binWidth + 0.00000001);       
            if (k < 0)
	    {
	        noLeft++;
              
            }
            else if (k >= noBins)
	    {
	        noRight++;
                
            }
            else
                frequency[k]++;
       
        }
        for (int k = 0; k < noBins; k++)
        {

	    double f = 0.0;
            if ( percentage )
                f =  100.0 * (double)frequency[k] / (double)nData; 
            else
	        f = (double)frequency[k];

	    yData[j].push_back( (float)f ); 
  
        



       }
       double maxFreq = MaxVal( yData[j]);
       double minFreq =  MinVal( yData[j] ) ;
       minimumFrequency = min( minimumFrequency, minFreq / double(nData));         
       //  cout << "Line 1275 minFreq=" << minFreq << " maxFreq=" << maxFreq << endl;


       double f = (int)ceil( maxFreq * 1.25) ; 

       if (f > yMax)
       {
           yMax = f;    

       }
       // cout << "Line 1285 ymax=" << yMax << endl;
 
    } // Finished looping through the data sets

   
    // cout << "Histogram Line 1294 yMax=" << yMax << endl;


   
    delete [] frequency;  
     


    /*************************************************************
    * Set up viewport and window
    ************************************************************/
    cbpgsvp(x1, x2, y1, y2);







    cbpgswin((float)xmin, (float)xmax, 0.0, (float)yMax);
         

    cbpgsci(1);     
    cbpgsch(1.0); 
    cbpgsfs(2);    
    cbpgslw(1);



    /****************************************************************
    * Draw the histograms
    ****************************************************************/
    
    if(noBins < 100)
    {
        for (int k = 0; k < noBins; k++)
        {
            vector< HistData > hist;
            for(int j = 0; j < noDataSets; j++)  
            {
	        hist.push_back( HistData(yData[j][k], j + 2) ); 

            } 

            /********************************************************
	    * Sort them into increasing bin height order
            *********************************************************/

            sort(hist.begin(), hist.end(), histCompare10);



            float yStart = 0.0;
            for(int j = 0; j < noDataSets; j++)
	    { 

	        if( (hist[j].x - yStart) < 0.0001)
	        {

                    yStart = hist[j].x;
	            continue;
                }
   
       
             
                cbpgsci(hist[j].index);    


	        float x1 = xmin + float(k) * binWidth  + 0.05 * binWidth;
	        float x2 = xmin + float(k + 1) * binWidth  - 0.05 * binWidth;

	        cbpgsfs(2);

	        cbpgrect(x1, x2, yStart, hist[j].x);
           
	        cbpgsfs(3);
	        cbpgrect(x1, x2, yStart, hist[j].x);

                yStart = hist[j].x;
	

            }
        
        }
    }   
    else // Draw lines
    {

        float *bin = new float[noBins];
        float *height = new float[noBins];

        for (int i = 0; i < noBins; i++)
        {
   
            bin[i] = xmin + binWidth * double(i) + binWidth / 2.0;
        }

 
        for(int j = 0; j < noDataSets; j++)  
        {
            cbpgsci(j + 1);    

	 
            for (int i = 0; i < noBins; i++)
            {
   
	        height[i] = (float)yData[j][i];
            }

            cbpgline(noBins, bin, height);
 
        }
        delete [] bin;
        delete [] height;

    }
    

    cbpgsch(0.7);

    for(int j = 0; j < noDataSets; j++)
    {
        cbpgsci(j + 1);
        char text[200];




        // Get some statistics
        float mean = Mean( data[j] );

        float median = Median( data[j] );

        float std = 0.0; 

        float mode = halfRangeMode( data[j], mean, std, median);






        float p1 = Percentile( data[j], 0.05);
        float p2 = Percentile( data[j], 0.95);

        sprintf(text, "%s Mean=%.2f Median=%.2f Mode=%.2f, 0.05 percentile=%.2f, 0.95=%.2f, N=%d", 
                    heading[j].c_str(), mean, median, mode, p1, p2, data[j].size() );
      

        cbpgsch(1.0);

        cbpgmtxt("T", -float(j + 3), 0.0, 0.0, text);
     



    }
  
    cbpgsci(1);

    char text[100];
    int k = 2;
    if (noLeft > 0)
    {
        sprintf( text, "No of data points < %.2f=%*d", xmin, (int(log10((float)noLeft) + 0.00001) + 1), noLeft);        
        cbpgmtxt("B", -float(k), 0.0, 0.0, text);
        k++;
    }

    if (noRight> 0)
    {
        sprintf( text, "No of data points > %.2f=%d", xmax, noRight);        
        cbpgmtxt("B", -float(k), 0.0, 0.0, text);
        k++;
    }

  
    cbpgsch(0.8);  
 
  

    if(noBins > getMaxNoBins() ) 
    {    
         binWidth = ((double)xmax - (double)xmin) / double( getMaxNoBins() );
         int nsub = 2;
         binWidth = cbpgrnd( binWidth, nsub );
    } 



    
    cbpgbox("bctsi", (float)binWidth, 5, "bctsi", 0.0, 0);

    cbpgsch(1.0);  
    cbpgbox("n", (float)binWidth, 5, "n", 0.0, 0); 
 
       
 
    char yLabel[100];

    cbpgsch(1.0);  

    if(noDataSets == 1)
    {
      if( percentage) {
        sprintf( yLabel, "%s %d %s", "FREQUENCY (%) (TOTAL=", data[0].size(), ")" );      
      }
      else {

          sprintf( yLabel, "%s %d %s", "FREQUENCY (TOTAL=", data[0].size(), ")" );      
 

      }

    }
    else
    {
        if(percentage)
            strcpy(yLabel, "Frequency (%)" );      
        else
            strcpy(yLabel, "Frequency" );      

    }
    cbpgsch(1.5);  
    cbpgmtxt("T", 2.0, 0.5, 0.5, title);

    cbpgslw(3);
 
    cbpgsch(1.2);  
    cbpglab(" ", yLabel, "");
    cbpgmtxt("B", 3.0, 0.5, 0.5, xLabel);

    cbpgslw(1);
 

    int nData = (int)data[0].size(); 
    if ( percentage )
    {
        yMax  = yMax * (double)nData / 100.0; 
  
    }


    cbpgswin(xmin, xmax, 0.0, yMax);



}




/**********************************************************************
*
*
*
**********************************************************************/
template<class type>

void drawGraph( vector<type> &xdata, 
                vector<type> &ydata, 
                vector<type> &yerrors,    
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2,
                float y1, 
                float y2,             
                type xmin1, 
                type xmax1, 
                type ymin1, 
                type ymax1, 
                bool xLog10 = false, 
                bool yLog10 = false,            
                bool equalAxes = false)
  
{
    
    int ndata = xdata.size();
 
    float xmin, xmax, ymin, ymax;
  
       
    xmin =  10000.0;
    xmax = -10000.0;
    ymin = xmin;
    ymax = xmax;
             
 
    for (int j = 0; j <  ndata; j++)
    {
     
        if (xdata[j] < xmin) xmin = (float)xdata[j];
        if (xdata[j] > xmax) xmax = (float)xdata[j];
        if (ydata[j] < ymin) ymin = (float)(ydata[j] - yerrors[j]);
        if (ydata[j] > ymax) ymax = (float)(ydata[j] + yerrors[j]);
    }
				  
    if ( fabs(ymax - ymin) < 1e-20) 
    {
        ymin = ymin - 0.1;
        ymax = ymax + 0.1;
    }    

    cbpgsci( 1 );
    cbpgsvp(x1, x2, y1, y2);

    if ( xLog10 && xmin > 0.0 && xmax > 0.0) {
        xmin = log10( xmin ); 
        xmax = log10( xmax ); 

    } 
    
    if ( yLog10 && ymin > 0.0 && ymax > 0.0) {
        ymin = log10( ymin ); 
        ymax = log10( ymax ); 

    } 
    

       
    cbpgrnge(xmin, xmax, &xmin, &xmax);
    cbpgrnge(ymin, ymax, &ymin, &ymax);

    if ( fabs(xmin1 - xmax1) > 1e-20 && xmin1 <= xmin && xmax1 >= xmax) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }
  
    if ( fabs(ymin1 - ymax1) > 1e-20 && ymin1 <= ymin && ymax1 >= ymax) 
    {
        ymin = ymin1;
        ymax = ymax1;
    }
  


    if (equalAxes)
    { 
	 cbpgwnad(xmin, xmax, ymin, ymax);
    }
    else
    {
        cbpgswin(xmin, xmax, ymin, ymax);
        
    }



    cbpgsch(1.0);
      
  
    cbpgsls(1);
    cbpgbox("bctsi", 0.0, 0, "bctsi", 0.0, 0);
    cbpgsch(1.0);
    cbpgslw(1);
    cbpgbox("n", 0.0, 0, "n", 0.0, 0);
   

    cbpgsch(1.2); 
    cbpgslw(3);
    cbpglab(" ", ylabel, title);
    cbpgmtxt("B", 2.0, 0.5, 0.5, xlabel );
  

    cbpgslw(1);
  
    cbpgsch(0.6);        

    for (int i = 0; i < ndata; i++)
    { 
        float x[1];
        x[0] = xdata[i];
        if ( xLog10) {
	    x[0] = log10( x[0] );        
       
        } 
    
        float y[1]; 
        y[0] = ydata[i];
        float y1[1];
        y1[0] = ydata[i] + yerrors[i];
        float y2[1];
        y2[0] = ydata[i] - yerrors[i];

        if ( yLog10) {
	    y[0] = log10( y[0] );        
            y1[0] = log10( y1[0] );        
            y2[0] = log10( y2[0] );        
       
        } 
    
        cbpgpt1( x[0], y[0], 9);

        cbpgerry( 1, x, y1, y2, 0.0);
 
  

    }       

           
    cbpgslw(1);
    cbpgsch(0.5);
     
}
/****************************************************************
*
*
*****************************************************************/
template<class type, class type1>
void drawGraph( 
                vector<type> &xdataIn,
                vector<type> &ydataIn,                
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2, 
                float y1, 
                float y2, 
                type1 xmin1 = 0, 
                type1 xmax1 = 0, 
                type1 ymin1 = 0, 
                type1 ymax1 = 0,   
                bool xLog10 = false,
                bool yLog10 = false,
		bool equalAxes = false)
  
{


  //  cout << "drawgraph line 1629\n";

    
    int ndata = xdataIn.size();

    float *xdata = new float[ndata];
    float *ydata = new float[ndata];

    float xmin, xmax, ymin, ymax;
  
       
    xmin =  10000.0;
    xmax = -10000.0;
    ymin = xmin;
    ymax = xmax;
             
    for (int j = 0; j <  ndata; j++)
    {
        xdata[j] = (float)xdataIn[j];
        ydata[j] = (float)ydataIn[j];

        if (xdata[j] < xmin) xmin = xdata[j];
        if (xdata[j] > xmax) xmax = xdata[j];
        if (ydata[j] < ymin) ymin = ydata[j];
        if (ydata[j] > ymax) ymax = ydata[j];
        

        if( xLog10) {
            xdata[j] = log10( xdata[j] );
        

        }

        if( yLog10) {
            ydata[j] = log10( ydata[j] );
        

        }


    }
				  
    if (fabs(ymax - ymin) < 1e-20) 
    {
        ymin = ymin - 0.1;
        ymax = ymax + 0.1;
    }    

    cbpgsci( 1 );
    cbpgsvp(x1, x2, y1, y2);

    if( xLog10 && xmin > 0.0 && xmax > 0.0) {
        xmin = log10( xmin );
        xmax = log10( xmax );

    }
    

    if( yLog10 && ymin > 0.0 && ymax > 0.0) {
        ymin = log10( ymin );
        ymax = log10( ymax );

    }


    cbpgrnge(xmin, xmax, &xmin, &xmax);
    cbpgrnge(ymin, ymax, &ymin, &ymax);

 


    if ( fabs((double)xmin1 - (double)xmax1) > 1e-20 && xmin1 <= xmin && xmax1 >= xmax) 


    {
        xmin = (float)xmin1;
        xmax = (float)xmax1;
    }
  
    if ( fabs((double)ymin1 - (double)ymax1) > 1e-20 && ymin1 <= ymin && ymax1 >= ymax) 

    {
        ymin = (float)ymin1;
        ymax = (float)ymax1;
    }
  


    if (equalAxes)
    { 
	 cbpgwnad(xmin, xmax, ymin, ymax);
    }
    else
    {
        cbpgswin(xmin, xmax, ymin, ymax);
        
    }
    cbpgsch(1.5);




        
    cbpgsls(1);
    cbpgbox("bctsi", 0.0, 0, "bctsi", 0.0, 0);
    cbpgsch(1.0);
    cbpgslw(1);
    cbpgbox("n", 0.0, 0, "n", 0.0, 0);
   
    cbpgsch(1.75); 
    cbpgslw(3);
    cbpglab((char *)" ", ylabel, title);
    cbpgmtxt("B", 2.0, 0.5, 0.5, xlabel );
  

    cbpgslw(1);
  
    cbpgsch(0.9);        



    cbpgsci( getColour() );  
      
    cbpgpt(ndata, xdata, ydata, getSymbol() );


    cbpgsci(1);


    cbpgslw(1);
    cbpgsch(0.5);

    delete [] xdata;
    delete [] ydata;


 

}


/**********************************************************************
*
**********************************************************************/
template<class T>

void drawGraph(
                vector<T> &xdata  , 
                vector<T> &xerrors  , 
                vector<T> &ydata  , 
                vector<T> &yerrors  ,
                vector<int>   &colourIndex,
                char *title, 
                char *xlabel, 
                char *ylabel, 
                float x1, 
                float x2,
                float y1, 
                float y2,             
                float xmin1, 
                float xmax1, 
                float ymin1, 
                float ymax1, 
                bool equalAxes)
  
{
    
    int ndata = xdata.size();


    // cout << "graph line 203 ndata=" << ndata << endl;

 
    float xmin, xmax, ymin, ymax;
  
       
    xmin =  10000.0;
    xmax = -10000.0;
    ymin = xmin;
    ymax = xmax;
             
  
  


    for (int j = 0; j <  ndata; j++)
    {
     
        if (xdata[j] < xmin) xmin = xdata[j];
        if (xdata[j] >  xmax) xmax = xdata[j];
        if (ydata[j] < ymin) ymin = ydata[j];
        if (ydata[j] > ymax) ymax = ydata[j];
    }
				  
    if (fabs(ymax - ymin) < 1e-10) 
    {
        ymin = ymin - 0.1;
        ymax = ymax + 0.1;
    }    

    cbpgsci( 1 );
    cbpgsvp(x1, x2, y1, y2);

     
    cbpgrnge(xmin, xmax, &xmin, &xmax);
    cbpgrnge(ymin, ymax, &ymin, &ymax);



    if ( fabs(xmin1 - xmax1) > 1e-6) 
    {
        xmin = xmin1;
        xmax = xmax1;
    }
  
    if ( fabs(ymin1 - ymax1) > 1e-6) 
    {
        ymin = ymin1;
        ymax = ymax1;
    }
  



    
    if (equalAxes)
    { 
	 cbpgwnad(xmin, xmax, ymin, ymax);
    }
    else
    {
        cbpgswin(xmin, xmax, ymin, ymax);
        
    }
    cbpgsch(1.5);
      
  
    cbpgsls(1);
    cbpgbox("bctsi", 0.0, 0, "bctsi", 0.0, 0);
    cbpgsch(1.0);
    cbpgslw(1);
    cbpgbox("n", 0.0, 0, "n", 0.0, 0);
   

    cbpgsch(1.5); 
    cbpgslw(3);
    cbpglab((char *)" ", ylabel, title);
    cbpgmtxt("B", 2.0, 0.5, 0.5, xlabel );
  

    cbpgslw(1);
  
    cbpgsch(0.9);        


     

       
    
    for (int i = 0; i < ndata; i++)
    { 
        cbpgsci( colourIndex[i] ); 
        cbpgpt1( xdata[i], ydata[i], 9);

   
   
        cbpgerr1(1, xdata[i], ydata[i], xerrors[i], 0);
       
        cbpgerr1(3, xdata[i], ydata[i], xerrors[i], 0);
   
        cbpgerr1(2, xdata[i], ydata[i], yerrors[i], 0);
       
        cbpgerr1(4, xdata[i], ydata[i], yerrors[i], 0);
   

    }       

           
    cbpgslw(1);
    cbpgsch(0.5);
 }



#endif


